/*
  $Id: Enhancer.java,v 1.7 1999/03/17 19:03:03 remek Exp $
  Revision:   $Revision: 1.7 $
  Updated:    $Date: 1999/03/17 19:03:03 $
  Updated by: $Author: remek $
  Copyright 1999 Northeast Parallel Architectures Center, Syracuse University
*/

import java.io.*;
import java.util.*;
import java.net.*;
import java.lang.*;

import javax.servlet.*;
import javax.servlet.http.*;

import org.w3c.dom.*;
import org.w3c.dom.html.*;
import org.openxml.*;
import org.openxml.parser.*;

public class EnhancerTxt extends HttpServlet 
{
    static HTMLDocument aDoc;

    public void doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException 
    {
	try{
	    
	URL targetURL;
	String temp = req.getParameter("url");
	if(temp==null){
	    reportError("url parameter not specified!", res);
	    return;
	}
	
	try{
	    targetURL = new URL(req.getParameter("url"));
	}
	catch (MalformedURLException e){
	    reportError("Malformed URL: " + e.toString(), res);
	    return;
	}
	
	HttpURLConnection connectionURL;
	try{
	    connectionURL = (HttpURLConnection)targetURL.openConnection();
	}
	catch(IOException e){
	    
	    reportError(e.toString(), res);
	    return;
	}
	
	String typeURL = connectionURL.getContentType();
	if(typeURL==null){
	    reportError("Could not open the connection to specified URL!",
			res);
	    return;
	}

	res.setContentType(typeURL);

	BufferedReader input;
	InputStream tempis = connectionURL.getInputStream();
	if(tempis==null){
	    reportError("Empty input stream!", res);
	    return;
	}
	    
	input = new BufferedReader(new InputStreamReader(tempis));

	if(typeURL.substring(0, 4).toUpperCase().compareTo("TEXT") != 0){
	    //unknown type content
	    OutputStreamWriter out;
	    out = new OutputStreamWriter(res.getOutputStream());
	    int c;
	    
	    while (-1 != ((c = input.read()))) 
		out.write(c);
	    
	    out.close();
	} else {
	    //text/html
	    
	    PrintWriter out;
	    out = res.getWriter();
	    
	    String str = null;
	    String wholeDoc = "";
	
	    try{
		while (null != ((str = input.readLine()))) 
		    wholeDoc = wholeDoc +  str + "\n";
	    }
	    catch(Exception e){
		reportError("Server closed connection.  URL not found?", res);
		return;
	    }

	    //String newDoc = processHead(wholeDoc, req);
	    String filteredDoc = processJS(wholeDoc);
	    StringReader aReader = new StringReader(filteredDoc);
	    HTMLParser aParser = new HTMLParser(aReader, null);
	    aDoc = (HTMLDocument)aParser.parseDocument();

	    showText(aDoc, res);

	}
	input.close ();
	
	}
	catch(Exception e){
	    reportError("unexpected exception " + e.toString(), res);
	}
	
    }

    public void reportError(String message, HttpServletResponse res)
	throws IOException 
    {
	res.setContentType("text/html");
	PrintWriter out;
	out = res.getWriter();
	out.println(message);
    }

    static void showText( Node node, HttpServletResponse res ) 
	throws IOException
    {
	res.setContentType("text/html");
        PrintWriter out;
        out = res.getWriter();

	while ( node != null ) {
	    if ( node.getNodeName().compareTo("#text") == 0 ) {
		out.println( node.getNodeValue() + "<BR>" );
            }
	    if ( node.hasChildNodes() ) {
		showText( node.getFirstChild(), res );
	    }
	    node = node.getNextSibling();
	}
    }

    public String processJS( String page )
    {
	int start = page.toUpperCase().indexOf("<SCRIPT");
	if ( start < 0 ) {
	    if ( page.indexOf("< ") > 0 )
		return "Improved filter needed.";
	    else
		return page;
	}
	else {
	    int end = page.toUpperCase().indexOf("</SCRIPT");
	    int last = page.indexOf('>', end);
	    if ( end < last ) {
		String firstpage = page.substring(0, start-1);
		String restpage = page.substring(last+1);
                if ( restpage.toUpperCase().indexOf("<SCRIPT") <  0 )
		    return firstpage + restpage;
		else
		    return firstpage + processJS( restpage );
	    }
	    else {
		return "Script Error!";
	    }
	}
    }
}

